unit ChildMainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    PipeWrite: THandle;
  end;

{$ifdef Ver90}
  //This exception class did not exist in Delphi 2
  EWin32Error = class(Exception);
{$endif}

var
  Form1: TForm1;

const
  PipeNameFixedPrefix = '\\.\pipe\';
  PipeName = PipeNameFixedPrefix + 'SampleNamedPipe';

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  PipeWrite := FileOpen(PipeName, fmOpenWrite);
  if PipeWrite = Invalid_Handle_Value then
    raise EWin32Error.Create('Cannot open pipe for writing');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CloseHandle(PipeWrite);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Msg: String;
begin
  Msg := Edit1.Text + #13#10;
  if FileWrite(PipeWrite, Msg[1], Length(Msg)) = Integer(HFile_Error) then
    raise EWin32Error.Create('Cannot write to named pipe');
end;

end.
