unit GridView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, Buttons, DBCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DBNavigator1: TDBNavigator;
    SpeedButtonView: TSpeedButton;
    DBGrid1: TDBGrid;
    RangeSpeedButton: TSpeedButton;
    Panel2: TPanel;
    LanguageSpeedButton: TSpeedButton;
    procedure SpeedButtonViewClick(Sender: TObject);
    procedure RangeSpeedButtonClick(Sender: TObject);
    procedure LanguageSpeedButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    CurrLocale: LCID;
  end;

var
  Form1: TForm1;

implementation

uses DataM, FormView, ReInit;

{$R *.DFM}

procedure TForm1.SpeedButtonViewClick(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.RangeSpeedButtonClick(Sender: TObject);
begin
  DataModule2.ChooseRange;
end;

const
  ENGLISH = (SUBLANG_ENGLISH_UK shl 10) or LANG_ENGLISH;
  ITALIAN = LANG_ITALIAN;

procedure TForm1.LanguageSpeedButtonClick(Sender: TObject);
var
  Locale: LCID;
begin
  if CurrLocale = ENGLISH then
    Locale := ITALIAN
  else
    Locale := ENGLISH;

  if LoadNewResourceModule(Locale) <> 0 then
  begin
    ReinitializeForms;
    CurrLocale := Locale;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // start with user locale (not always the case, though)
  CurrLocale := GetUserDefaultLCID;
end;

end.
